#include <Servo.h>
#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978
#define REST      0
#include <OneWire.h>
#include <DallasTemperature.h>
#define ONE_WIRE_BUS 9

// Setup a oneWire instance to communicate with any OneWire device (for temperature sensor)
OneWire oneWire(ONE_WIRE_BUS);  

// Pass oneWire reference to DallasTemperature library (for temperature sensor)
DallasTemperature sensors(&oneWire);

// C++ code
//This code is for my RoboRamen. The ultrasonic sensor senses how far it is from the hot pot
// and causes the red LED light to turn on if it is closer than 4 cm to the hot pot. The temperature
// sensor, when it senses 100 degrees Celsius or the water boiling, causes the servo motor to turn 
// (which operates a slider-crank mechanism) that pushes the ramen noodles into the pot. A timer is set from 
// there with the delay function and after it is done, the alarm goes off to alert that the ramen
// is done. The loop for the code stops after that as well. 

int cm = 0;     // variable to store measured distance (in cm) for ultrasonic sensor

// Code to get distance from the ultrasonic sensor
long readUltrasonicDistance(int triggerPin, int echoPin)
{
  pinMode(triggerPin, OUTPUT);  // Clear the trigger
  digitalWrite(triggerPin, LOW);
  delayMicroseconds(2);
  // Sets the trigger pin to HIGH state for 10 microseconds
  digitalWrite(triggerPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(triggerPin, LOW);
  pinMode(echoPin, INPUT);
  // Reads the echo pin, and returns the sound wave travel time in microseconds
  return pulseIn(echoPin, HIGH);
}

int celsius = 0; // variable to store celsius temperature from sensor

int pos = 0;    // variable to store the servo position

Servo myservo; // create servo object to control servo reeling in temperature probe and pushing crank

int x = 1;      //variable to stop the loop when the ramen is done

// for buzzer melody:
int tempo = 114; // set tempo of buzzer song

// set melody for the buzzer alarm

int melody[] = {

  // Never Gonna Give You Up - Rick Astley
  // Arranged by Chlorondria
  NOTE_A4,16, NOTE_B4,16, NOTE_D5,16, NOTE_B4,16,
  NOTE_FS5,-8, NOTE_FS5,-8, NOTE_E5,-4, NOTE_A4,16, NOTE_B4,16, NOTE_D5,16, NOTE_B4,16,

  NOTE_E5,-8, NOTE_E5,-8, NOTE_D5,-8, NOTE_CS5,16, NOTE_B4,-8, NOTE_A4,16, NOTE_B4,16, NOTE_D5,16, NOTE_B4,16, //18
  NOTE_D5,4, NOTE_E5,8, NOTE_CS5,-8, NOTE_B4,16, NOTE_A4,8, NOTE_A4,8, NOTE_A4,8, 
  NOTE_E5,4, NOTE_D5,2, NOTE_A4,16, NOTE_B4,16, NOTE_D5,16, NOTE_B4,16,
  NOTE_FS5,-8, NOTE_FS5,-8, NOTE_E5,-4, NOTE_A4,16, NOTE_B4,16, NOTE_D5,16, NOTE_B4,16,
  NOTE_A5,4, NOTE_CS5,8, NOTE_D5,-8, NOTE_CS5,16, NOTE_B4,8, NOTE_A4,16, NOTE_B4,16, NOTE_D5,16, NOTE_B4,16,

  NOTE_D5,4, NOTE_E5,8, NOTE_CS5,-8, NOTE_B4,16, NOTE_A4,4, NOTE_A4,8,  //23
  NOTE_E5,4, NOTE_D5,2, REST,4,
};

// more buzzer melody semantics
int notes = sizeof(melody) / sizeof(melody[0]) / 2;

// this calculates the duration of a whole note in ms
int wholenote = (60000 * 4) / tempo;

int divider = 0, noteDuration = 0;

void setup()
{
  // attach led to pin 13 
  pinMode(11, OUTPUT);
  
  sensors.begin();  // Start up the library for temperature sensor
  Serial.begin(9600);
  
  // initilize serial communication for buzzer and attaches it to pin 7
  Serial.begin(9600);
  pinMode(7, OUTPUT);
  
  // attaches the servo for reeling in the temp probe on pin 12 to the servo object
  myservo.attach(12); // attach servo to pin 12
}

void loop()
{
  if (x==1) {
    // Set distance variable (in cm) for ultrasonic sensor
    cm = 0.01723 * readUltrasonicDistance(8, A1);
    delay(10); // Delay a little bit to improve simulation performance
    Serial.print(cm);
    Serial.print("cm, ");
  
    // alarm if the object is too close:
    if(cm <= 4) {
      tone(7, 1000, 100);
      tone(7, 1000, 100);
      tone(7, 1000, 100);
    }

  // Send the command to get temperatures
  sensors.requestTemperatures(); 

  //print the temperature in Celsius
  Serial.print("Temperature: ");
  Serial.print(sensors.getTempCByIndex(0));
  Serial.print(" C  |  ");
  
    // if boiling point is reached, trigger the servo mount to rotate
    // and push the ramen noodles into the pot and reel the temp probe in
    if (sensors.getTempCByIndex(0) >= 100) {
      myservo.write(120);              // tell servo to rotate 
      delay(1650);              
      myservo.write(90);               // stop the servo rotation
      delay(6000);                     // set timer for the noodles to cook
      for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {

        // calculates the duration of each note
        divider = melody[thisNote + 1];
        if (divider > 0) {
            // regular note, just proceed
            noteDuration = (wholenote) / divider;
        } else if (divider < 0) {
            // dotted notes are represented with negative durations!!
            noteDuration = (wholenote) / abs(divider);
            noteDuration *= 1.5; // increases the duration in half for dotted notes
        }

        // we only play the note for 90% of the duration, leaving 10% as a pause
        tone(7, melody[thisNote], noteDuration * 0.9);

        // Wait for the specief duration before playing the next note.
        delay(noteDuration);

        // stop the waveform generation before the next note.
        noTone(7);
      }
      x = 0;            //cause if statement to be false so the loop stops running
}
  }
}
